<template>
  <button
    :class="{
      button: true, 
      contained: type === 'contained', 
      outlined: type === 'outlined',
      text: type === 'text',
      lg: size === 'lg', 
      md: size === 'md', 
      sm: size === 'sm', 
      xsm: size === 'xsm', 
      stretched: size === 'stretched',
      primary: color === 'primary',
      dark: color === 'dark',
      grey: color === 'grey',
      white: color === 'white',
      round: round,
      disabled: disabled,
      pressed: pressed,
      flat: flat
      }"
    :disabled="disabled"
    :type="noSubmit ? 'button' : 'submit'"
    v-ripple="rippleColor"
  >
    <span :class="{icon: true, 'fill-dark': light}" v-if="$slots.icon">
      <slot name="icon"></slot>
    </span>
    <span class="label" v-if="$slots.default">
      <slot></slot>
    </span>
  </button>
</template>

<script>
export default {
  name: "Button",
  data() {
    return {
      pressed: false
    };
  },
  props: {
    type: {
      type: String
    },
    disabled: {
      type: Boolean,
      default: false
    },
    color: {
      type: String,
      default: "primary"
    },
    light: {
      type: Boolean,
      default: false
    },
    size: {
      type: String,
      default: "md"
    },
    flat: {
      type: Boolean,
      default: false
    },
    round: {
      type: Boolean,
      default: false
    },
    noSubmit: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    rippleColor() {
      switch (this.color) {
        case "primary":
          return "rgba(230, 179, 30, 0.2)";
        case "dark":
          return "rgba(0, 0, 0, .2)";
        default:
          return "rgba(255, 255, 255, 0.2)";
      }
      return "rgba(255, 255, 255, 0.2)";
    }
  }
};
</script>

<style lang="stylus" scoped>
@import '~assets/styles/variables';

.button {
  border: none;
  font-family: inherit;
  direction ltr
  font-size: 1.4rem;
  outline: none;
  position: relative;
  z-index: 1;
  display: flex;
  flex-direction: row-reverse;
  align-items: center;
  justify-content: center;
  overflow: hidden;

  .icon {
    margin-left: .7rem;
    display: flex;
    align-items: center;
    fill: $black;
  }

  .icon:last-of-type {
    margin-left: 0;
  }

  &:hover {
    cursor: pointer;
  }
}

.contained {
  transition: box-shadow 0.2s;
  border-radius: 4px;
  box-shadow: 0px 3px 3px -2px rgba(0, 0, 0, 0.2), 0px 2px 5px 0px rgba(0, 0, 0, 0.14), 0px 1px 5px 0px rgba(0, 0, 0, 0.12);

  &:hover {
    box-shadow: 0px 4px 5px -2px rgba(0, 0, 0, 0.2), 0px 3px 7px 0px rgba(0, 0, 0, 0.14), 0px 2px 7px 0px rgba(0, 0, 0, 0.12);

    &::after {
      width: 100%;
      height: 100%;
      display: block;
      content: '';
      position: absolute;
      top: 0;
      left: 0;
      z-index: 2;
      background-color: rgba(white, 0.09);
    }
  }

  &:active {
    box-shadow: 0px 5px 8px -2px rgba(0, 0, 0, 0.2), 0px 4px 10px 0px rgba(0, 0, 0, 0.14), 0px 4px 10px 0px rgba(0, 0, 0, 0.12);
  }

  &.sm {
    padding: 0 1.6rem;
    height: 3.6rem;
    min-width: 6.4rem;
  }

  &.md {
    padding: 1rem 5rem;
  }

  &.lg {
    padding: 1.2rem 10rem;
  }

  &.stretched {
    width: 100%;
  }

  &.flat {
    box-shadow: none;

    &:hover {
      box-shadow: none;
    }
  }

  &.primary {
    background-color: $primary;
    color: $black;
  }

  &.white {
    background-color: $white;
    color: $black;
  }

  &.disabled {
    background-color: #CCCCCC;
    box-shadow: none;
    color: #909090;
  }

  &:focus::after {
    width: 100%;
    height: 100%;
    display: block;
    content: '';
    position: absolute;
    top: 0;
    left: 0;
    z-index: 2;
    background-color: rgba(white, 0.2);
  }
}

.outlined {
  border-radius: 4px;
  background-color: transparent;
  transition: none;

  &.sm {
    padding: 0 1.6rem;
    height: 3.6rem;
    min-width: 6.4rem;
  }

  &.md {
    padding: 1rem 5rem;
  }

  &.lg {
    padding: 1rem 10rem;
  }

  &.stretched {
    width: 100%;
  }

  &.round {
    border-radius: 50%;
    height: auto;
    min-width: auto;
    padding 0
    &.sm {
      padding: 1.2rem;
    }
  }

  &.primary {
    border: 1px solid $primary;
    color: $primary;

    &:hover {
      background-color: rgba($primary, 0.1);
    }

    &:focus {
      background-color: rgba($primary, 0.3);
    }
  }

  &.dark {
    color: $black;
    border: 1px solid $black;
    .icon {
      fill: $black;
    }

    &:hover, &:focus {
      background-color: rgba(black, 0.09);
    }
  }

  &.white {
    color: $white;
    border: 1px solid $white;
    .icon {
      fill: $white;
    }

    &:hover, &:focus {
      background-color: rgba(white, 0.09);
    }
  }

  &.grey {
    color $grey
    border 1px solid rgba($grey, .2)
    .icon {
      fill: $grey;
    }
    &:hover, &:focus {
      background-color: rgba(black, 0.09);
    }
  } 
}

.text {
  border-radius: 4px;
  background-color: transparent;
  transition: none;
  color: $black;

  &:hover, &:focus {
    background-color: rgba(#CCCCCC, 0.25);
  }

  &.xsm {
    padding 0.5rem
    min-width: 4rem;
  }

  &.sm {
    padding: 0 1.6rem;
    height: 3.6rem;
    min-width: 6.4rem;
  }

  &.md {
    padding: 1rem 5rem;
  }

  &.lg {
    padding: 1rem 10rem;
  }

  &.stretched {
    width: 100%;
  }

  &.primary {
    color: $primary;

    .icon {
      fill: $primary;
    }

    &:hover, &:focus {
      background-color: rgba($primary, 0.25);
    }
  }

  &.white {
    color: $white;

    .icon {
      fill: $white;
    }

    &:hover, &:focus {
      background-color: rgba($white, 0.05);
    }
  }

  &.dark {
    color rgba($black, .6)

    .icon {
      fill rgba($black, .6)
    }

    &:hover, &:focus {
      background-color: rgba(black, 0.09);
    }
  }

  &.round {
    border-radius: 50%;
    height: auto;
    min-width: auto;

    &.xsm {
      padding: .5rem;
    }

    &.sm {
      padding: 1.2rem;
    }

    &.md {
      padding: 2rem;
    }

    &.lg {
      padding: 4rem;
    }
  }

  &.disabled {
    opacity .5
  }
}

// Helper classes

.fill-dark
  svg
    fill rgba($black, .6)
</style>

